package Catalyst::Plugin::ErrorCatcher::Verbose;
# ABSTRACT: ErrorCatcher plus Dumper $args (no truncated)
$Catalyst::Plugin::ErrorCatcher::Verbose::VERSION = '0.142330';
use Moose;
extends qw(Catalyst::Plugin::ErrorCatcher);

use Data::Dumper;

after _prepare_message => sub {
    my $c = shift;

    my $feedback = $c->_errorcatcher_msg;

    _append_output_params(\$feedback, 'QUERY', $c->request->query_parameters);
    _append_output_params(\$feedback, 'BODY', $c->request->body_parameters);

    if (defined $feedback) {
        $c->_errorcatcher_msg($feedback);
    }
};

sub _append_output_params {
    my ($fb_ref, $label, $params) = @_;

    return unless keys %$params;

    local $Data::Dumper::Sortkeys = 1;
    Catalyst::Plugin::ErrorCatcher::append_feedback($fb_ref, "Params ($label) Verbose:");
    Catalyst::Plugin::ErrorCatcher::append_feedback($fb_ref, Dumper $params);
    Catalyst::Plugin::ErrorCatcher::append_feedback_emptyline($fb_ref);
}

1;

__END__

=pod

=head1 NAME

Catalyst::Plugin::ErrorCatcher::Verbose - ErrorCatcher plus Dumper $args (no truncated)

=head1 VERSION

version 0.142330

=head1 AUTHOR

Tomohiro Hosaka <bokutin@bokut.in>

=head1 COPYRIGHT AND LICENSE

This software is copyright (c) 2014 by Tomohiro Hosaka.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

=cut
