use Modern::Perl;
use Test::More;

use File::Temp;
use HTTP::Request::Common;
use IO::All;
use Plack::Test;

use lib "t/lib/TestApp/lib";
BEGIN {
    $ENV{ErrorCatcherName}    = 'ErrorCatcher';
    $ENV{ErrorCatcherFileDir} = File::Temp->newdir;
}
my $app = do "t/lib/TestApp/testapp.psgi";

my $dir = io($ENV{ErrorCatcherFileDir});

test_psgi $app, sub {
    my $cb  = shift;
    my $res = $cb->(GET "/");
    is $res->content, "Hello World";
};

test_psgi $app, sub {
    my $cb  = shift;
    my $res = $cb->(GET "/die");
    like $res->content, qr/Please come back later/;
};

my @files = $dir->all_files;
is @files, 1;

unlike $files[0]->all, qr/Params \(BODY\) Verbose/;
unlike $files[0]->all, qr/\$VAR1/;

done_testing();
